#ifndef LINEINTER_H_INCLUDED
#define LINEINTER_H_INCLUDED

#include <iostream>
#include <fstream>

const int BUFFER = 512;

struct Point
{
    double x;
    double y;
};

class TableFunction
{
private:

    double a;// 
    double b;// 
    Point *values;// 
    int number;// 

    bool calculationLinearApproximation(double *A, double *B);//   

public:

    // 
    TableFunction();

    // 
    TableFunction(double a, double b, int number);

    //  
    TableFunction(const TableFunction &cpy);//  ,     .
    TableFunction & operator= (const TableFunction &cpy);

    TableFunction & operator+= (const TableFunction &g);//g - ,     .
    TableFunction & operator-= (const TableFunction &g);
    TableFunction & operator*= (const TableFunction &g);

    void operator+= (double indent);//, indent - ,      .
    void operator-= (double indent);
    void operator*= (double indent);

    void print()    const;//  
    double getDX()  const;//       

    bool loadFromFile(const char *fileName);//   .
	bool saveToFile(const char *fileName);//     Filename.

    std::string getFunctionOfLinearApproximation();//     .
    bool linearApproximate();// .
    bool linearApproximateAndChangeDX(int number);//     .

    // 
    ~TableFunction();//     
};

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

TableFunction operator+ (const TableFunction &LHS, const TableFunction &RHS);
TableFunction operator- (const TableFunction &LHS, const TableFunction &RHS);
TableFunction operator* (const TableFunction &LHS, const TableFunction &RHS);
TableFunction operator+ (const TableFunction &LHS, double RHS);
TableFunction operator- (const TableFunction &LHS, double RHS);
TableFunction operator* (const TableFunction &LHS, double RHS);
TableFunction operator- (const TableFunction &LHS);

std::ostream & operator<< (std::ostream &os, const TableFunction &RHS);

#endif // LINEINTER_H_INCLUDED
